/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import java.awt.*;

public interface IFighter {
  public void init();
  public void update(int f2X, int f1X, int diff);
  public void damage();
  public void punch();
  public boolean isPunched();
  public void setOpponent(IFighter opponent);
  public void update();
  public Image getImage();
  public int getX();
  public int getY();
  public void update(int otherX, int diff);
  public void moveLeft();
  public void moveRight();
  public void kick();
  public void jump();
  public void block();
  public void unblock();
  public void setFighter(boolean leftFighter);
  public void setAutomatic(boolean auto);
  public int getVitality();
  public void resetVitality();
  public void setWinner();
  public boolean isDead();
}