/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class SelectCharacter extends FrameBuilder {

  private class SlideRectangle extends InputAdapter {
    public void inputLeft() {
      if (dc == 0 && x > 0 && dc == 0) {
        Jukebox.SLIDE.play();
        newX = x - 1;
        di = 3;
        dc = 4;
      }
    }

    public void inputRight() {
      if (dc == 0 && x < 2) {
        Jukebox.SLIDE.play();
        newX = x + 1;
        di = 2;
        dc = 4;
      }
    }

    public void inputUp() {
      if (dc == 0 && y > 0) {
        Jukebox.SLIDE.play();
        newY = y - 1;
        di = 0;
        dc = 4;
      }
    }

    public void inputDown() {
      if (dc == 0 && y < 1) {
        Jukebox.SLIDE.play();
        newY = y + 1;
        di = 1;
        dc = 4;
      }
    }

    public void inputStart() {
      InputFactory.getInputSource().clearInputListener();
      Jukebox.CHOSEN.play();
    }
  }

  Image background, all, name[][] = new Image[2][3], choose;
  int cx, cy, x, y, dx, dy, dc, di, newX, newY, chx;
  int dis[][][] = { { {0, -15}, {0, -45}, {0, -45}, {0, -15} },
  { {0, 15}, {0, 45}, {0, 45}, {0, 15} },
  { {15, 0}, {45, 0}, {45, 0}, {15, 0} },
      { {-15, 0}, {-45, 0}, {-45, 0}, {-15, 0} } };
  int[][] ncx = new int[2][3];
  boolean e;
  int[][] fNum = { { 5, 6, 2 }, { 1, 3, 4 } };
  Audio musicMenu;

  public void characterSelectionComplete() {
    Jukebox.stopMusic();
    MeatFighter.getInstance().characterSelected(fNum[y][x]);
  }

  public void init() {
    background = Gallery.BACKGROUND_VS;
    choose = Gallery.TEXT_CHOOSE_YOUR_PLAYER;
    name = Gallery.TEXT_NAME;

    for(y = 0; y < 2; y++)
      for(x = 0; x < 3; x++)
        ncx[y][x] = (640 - name[y][x].getWidth(null)) >> 1;

    all = Gallery.FIGHTERS;
    dx = cx = (640 - all.getWidth(null)) >> 1;
    dy = cy = (480 - all.getHeight(null)) >> 1;
    chx = (640 - choose.getWidth(null)) >> 1;
    x = y = 0;

    Chaotic.refresh();

    Jukebox.CHOSEN.setAudioListener(new AudioListener() {
      public void audioStopped() {
        characterSelectionComplete();
      }
    });
    musicMenu = Jukebox.MUSIC_SELECT_CHARACTER;
    Jukebox.loopMusic(musicMenu);

    InputFactory.getInputSource().setInputListener(new SlideRectangle());
  }

  public void updateState() {
    if (dc > 0) {
      if (--dc == 0) {
        x = newX;
        y = newY;
      }
      dx += dis[di][dc][0];
      dy += dis[di][dc][1];
    }
    e = !e;
  }

  public boolean isBackgroundSame() {
    return true;
  }

  public void renderBackground(Graphics g) {
    g.drawImage(background, 0, 0, null);
    g.drawImage(all, cx, cy, null);
  }

  public void renderBackground(
      Graphics g, int x, int y, int width, int height) {
    renderBackground(g);
  }

  public void renderForeground(Graphics g) {
    drawSprite(g, name[y][x], ncx[y][x], 370);
    drawSprite(g, choose, chx, 90);
    g.setColor((e) ? Color.blue : Color.white);
    g.drawRect(dx, dy, 119, 119);
    markDirtyRegion(dx, dy, 120, 120);
  }
}
