/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class VS extends FrameBuilder implements AudioListener {

  Image background, nameLeft, nameRight, portraitLeft, portraitRight, vs;
  int xLeft, xRight, fLeft, fRight;
  Audio musicBegin;

  private Image getPortrait(int f, boolean isRight) {

    if (f == 6)
      return Gallery.BEEF[0];

    return Gallery.PORTRAIT[f][isRight ? 0 : 1];
  }

  private Image getName(int f) {

    switch(f) {
      case 0: return Gallery.TEXT_NAME[1][0];
      case 1: return Gallery.TEXT_NAME[0][2];
      case 2: return Gallery.TEXT_NAME[1][1];
      case 3: return Gallery.TEXT_NAME[1][2];
      case 4: return Gallery.TEXT_NAME[0][0];
      case 5: return Gallery.TEXT_NAME[0][1];
      default: return null;
    }
  }

  public VS(int fLeft, int fRight) {

    this.fLeft = fLeft;
    this.fRight = fRight;
  }

  public void audioStopped() {
    MeatFighter.getInstance().startStage();
  }

  public void init() {
    background = Gallery.BACKGROUND_VS;
    vs = Gallery.TEXT_VS;
    nameLeft = getName(fLeft);
    nameRight = getName(fRight);
    portraitLeft = getPortrait(fLeft, false);
    portraitRight = getPortrait(fRight, true);
    if (nameLeft != null)
      xLeft = (300 - nameLeft.getWidth(null)) >> 1;
    if (nameRight != null)
      xRight = ((300 - nameRight.getWidth(null)) >> 1) + 340;

    musicBegin = Jukebox.MUSIC_VS;
    musicBegin.setAudioListener(this);
    Jukebox.playMusic(musicBegin);
  }

  public void updateState() {
  }

  public boolean isBackgroundSame() {
    return true;
  }

  public void renderBackground(Graphics g) {
    g.drawImage(background, 0, 0, null);
    g.drawImage(portraitLeft, 50, 140, null);
    g.drawImage(portraitRight, 390, 140, null);
    g.drawImage(vs, 278, 190, null);
    if (nameLeft != null)
      g.drawImage(nameLeft, xLeft, 350, null);
    if (nameRight != null)
      g.drawImage(nameRight, xRight, 350, null);
  }

  public void renderBackground(
      Graphics g, int x, int y, int width, int height) {
    renderBackground(g);
  }

  public void renderForeground(Graphics g) {
  }
}