/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class WinningScene extends FrameBuilder {

  public static final int STATE_SHADOW_LOWER = 0;
  public static final int STATE_CLOSE_UP_MIDDLE = 1;
  public static final int STATE_SHADOW_MIDDLE = 2;
  public static final int STATE_CLOSE_UP_UPPER = 3;
  public static final int STATE_SHADOW_UPPER = 4;
  public static final int STATE_DROP_PAUSE = 5;
  public static final int STATE_TROPHY_DROP = 6;
  public static final int STATE_CREDITS = 7;
  public static final int STATE_THANKS_FOR_PLAYING = 8;
  public static final int STATE_THE_END = 9;
  public static final int STATE_RESTART_PAUSE = 10;

  Image shadow[] = new Image[3], walk[] = new Image[4],
  winImg, trophy, director, artist, birken, theend, programmer,
  thanks;
  Graphics g;
  int state = 0, x = 315, y = 480, si = 0, yi = 0;
  int fr[] = { 0, 0, 0, 1, 1, 1, 2, 2, 2, 1, 1, 1 };
  int wp[] = { 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3,
    2, 2, 2, 2, 2, 1, 1, 1, 1, 1}, wpi = 0;
  Image backgroundWin1, backgroundWin2, backgroundWin3, backgroundWin4;
  boolean isBackgroundSame;
  int fighter;
  Audio musicWinning;

  public WinningScene(int fighter) {
    this.fighter = fighter;
  }

  public void loadFighter(int fighter) {

    if (fighter == 7) {
      loadHumanBeef();
      return;
    }

    Image[] fighterImages = null;

    switch(fighter) {
      case 1: fighterImages = Gallery.SAL[0]; break;
      case 2: fighterImages = Gallery.RAT[1]; break;
      case 3: fighterImages = Gallery.OSCAR[1]; break;
      case 4: fighterImages = Gallery.HOT[1]; break;
      case 5: fighterImages = Gallery.CORNELIUS[1]; break;
      case 6: fighterImages = Gallery.OLIVER[1]; break;
    }

    for(int i = 0; i < 4; i++)
      walk[i] = fighterImages[i];

    winImg = fighterImages[fighterImages.length - 1];
  }

  public void loadHumanBeef() {
    Image beef1 = Gallery.HUMAN_BEEF[0][0];
    Image beef2 = Gallery.HUMAN_BEEF[0][1];

    walk = new Image[] { beef1, beef1, beef2, beef2 };
    winImg = beef2;
  }

  public void init() {

    musicWinning = Jukebox.MUSIC_WINNING;

    trophy = Gallery.TROPHY;
    director = Gallery.TEXT_DIRECTOR;
    artist = Gallery.TEXT_GRAPHICS_ARTIST;
    birken = Gallery.TEXT_MICHAEL_BIRKEN;
    theend = Gallery.TEXT_THE_END;
    programmer = Gallery.TEXT_PROGRAMMER;
    thanks = Gallery.TEXT_THANKS_FOR_PLAYING;

    backgroundWin1 = Gallery.BACKGROUND_WIN[0];
    backgroundWin2 = Gallery.BACKGROUND_WIN[1];
    backgroundWin3 = Gallery.BACKGROUND_WIN[2];
    backgroundWin4 = Gallery.BACKGROUND_WIN[3];

    int i;
    if (fighter == 5)
      shadow = Gallery.SHADOW_C;
    else
      shadow = Gallery.SHADOW;
    loadFighter(fighter);

    Jukebox.playMusic(musicWinning);
  }

  public void updateState() {
    switch(state) {

      case STATE_SHADOW_LOWER:
        if (y == 350) {
          isBackgroundSame = false;
          state = STATE_CLOSE_UP_MIDDLE;
          x = -120;
        } else {
          if (++yi == 2) {
            yi = 0;
            y--;
          }
          if (++si == 11)
            si = 0;
        }
        break;

      case STATE_CLOSE_UP_MIDDLE:
        if (x >= 640) {
          isBackgroundSame = false;
          state = STATE_SHADOW_MIDDLE;
          x = 315;
          y = 210;
          si = yi = 0;
        } else {
          x+=2;
          if (++wpi == 28)
            wpi = 0;
        }
        break;

      case STATE_SHADOW_MIDDLE:
        if (y == 110) {
          isBackgroundSame = false;
          state = STATE_CLOSE_UP_UPPER;
          x = -120;
        } else {
          if (++yi == 2) {
            yi = 0;
            y--;
          }
          if (++si == 11)
            si = 0;
        }
        break;

      case STATE_CLOSE_UP_UPPER:
        if (x >= 280) {
          isBackgroundSame = false;
          state = STATE_SHADOW_UPPER;
          x = 315;
          y = 72;
          si = yi = 0;
        } else {
          x+=2;
          if (++wpi == 28)
            wpi = 0;
        }
        break;

      case STATE_SHADOW_UPPER:
        if (y == 40) {
          isBackgroundSame = false;
          state = STATE_DROP_PAUSE;
          x = 30;
          y = -trophy.getHeight(null)-5;
        } else {
          if (++yi == 2) {
            yi = 0;
            y--;
          }
          if (++si == 11)
            si = 0;
        }
        break;

      case STATE_DROP_PAUSE:
        if (--x == 0)
          state = STATE_TROPHY_DROP;
        break;

      case STATE_TROPHY_DROP:
        if (y > 120) {
          Jukebox.SPLAT.play();
          isBackgroundSame = false;
          state = STATE_CREDITS;
          x = (640-birken.getWidth(null)) >> 1;
          y = 480;
        } else
          y += 20;
        break;

      case STATE_CREDITS:
        if (y < -530) {
          state = STATE_THANKS_FOR_PLAYING;
          x = (640-thanks.getWidth(null)) >> 1;
          y = 480;
        } else
          y -= 3;
        break;

      case STATE_THANKS_FOR_PLAYING:
        if (y < -30) {
          state = STATE_THE_END;
          x = (640-theend.getWidth(null)) >> 1;
          y = 480;
        } else
          y -= 3;
        break;

      case STATE_THE_END:
        if (y < 225) {
          si = 72;
          isBackgroundSame = false;
          state = STATE_RESTART_PAUSE;
        } else
          y -= 3;
        break;

      case STATE_RESTART_PAUSE:
        if (--si == 0)
          MeatFighter.getInstance().resetTheGame();
      break;
    }
  }

  public boolean isBackgroundSame() {
    boolean retVal = isBackgroundSame;
    isBackgroundSame = true;
    return retVal;
  }

  public void renderBackground(Graphics g) {
    switch(state) {

      case STATE_SHADOW_LOWER:
      case STATE_SHADOW_MIDDLE:
      case STATE_SHADOW_UPPER:
        g.drawImage(backgroundWin1, 0, 0, null);
        break;

      case STATE_CLOSE_UP_MIDDLE:
        g.drawImage(backgroundWin2, 0, 0, null);
        break;

      case STATE_CLOSE_UP_UPPER:
        g.drawImage(backgroundWin3, 0, 0, null);
        break;

      case STATE_DROP_PAUSE:
      case STATE_TROPHY_DROP:
        g.drawImage(backgroundWin4, 0, 0, null);
        g.drawImage(walk[0], 120, 200, null);
        break;

      case STATE_CREDITS:
      case STATE_THANKS_FOR_PLAYING:
      case STATE_THE_END:
        g.drawImage(backgroundWin4, 0, 0, null);
        g.drawImage(winImg, 120, 200, null);
        g.drawImage(trophy, 290, 127, null);
        break;

      case STATE_RESTART_PAUSE:
        g.drawImage(backgroundWin4, 0, 0, null);
        g.drawImage(winImg, 120, 200, null);
        g.drawImage(trophy, 290, 127, null);
        g.drawImage(theend, x, y, null);
        break;
    }
  }

  public void renderBackground(
      Graphics g, int x, int y, int width, int height) {
    renderBackground(g);
  }

  public void renderForeground(Graphics g) {
    switch(state) {

      case STATE_SHADOW_LOWER:
        drawSprite(g, shadow[fr[si]], x, y);
        break;

      case STATE_CLOSE_UP_MIDDLE:
        drawSprite(g, walk[wp[wpi]], x, 230);
        break;

      case STATE_SHADOW_MIDDLE:
        drawSprite(g, shadow[fr[si]], x, y);
        break;

      case STATE_CLOSE_UP_UPPER:
        drawSprite(g, walk[wp[wpi]], x, 230);
        break;

      case STATE_SHADOW_UPPER:
        drawSprite(g, shadow[fr[si]], x, y);
        break;

      case STATE_DROP_PAUSE:
        drawSprite(g, walk[0], 120, 200);
        break;

      case STATE_TROPHY_DROP:
        drawSprite(g, trophy, 290, y);
        break;

      case STATE_CREDITS:
        drawSprite(g, director, x-30, y-30);
        drawSprite(g, birken, x, y);
        drawSprite(g, artist, x-30, y+220);
        drawSprite(g, birken, x, y+250);
        drawSprite(g, programmer, x-30, y+470);
        drawSprite(g, birken, x, y+500);
        break;

      case STATE_THANKS_FOR_PLAYING:
        drawSprite(g, thanks, x, y);
        break;

      case STATE_THE_END:
        drawSprite(g, theend, x, y);
        break;

      case STATE_RESTART_PAUSE:
        break;
    }
  }
}